diff --git a/test/integration/daemon_auto_retry_test.rb b/test/integration/daemon_auto_retry_test.rb
new file mode 100644
index 000000000..2b00d4205
--- /dev/null
+++ b/test/integration/daemon_auto_retry_test.rb
@@ -0,0 +1,227 @@
+require "test_helper"
+require "hive/commands/init"
+require "hive/commands/status"
+require "hive/daemon/health_probe"
+require "hive/daemon/stale_agent_healer"
+require "hive/daemon/status_consumer"
+require "hive/daemon/logger"
+require "hive/daemon/concurrency_controller"
+require "hive/daemon/policy"
+require "hive/markers"
+
+# End-to-end acceptance for the probe-gated auto-retry: drive the real
+# `hive status --json` pipeline (so the marker `message`/`reason` attrs are
+# proven to reach the classifier), then clear through the real Markers +
+# Policy re-dispatch chain with an injected fake probe.
+class DaemonAutoRetryTest < Minitest::Test
+  include HiveTestHelper
+
+  Result = Hive::Daemon::HealthProbe::Result
+  HEADLESS_CFG = { "claude" => { "mode" => "headless" } }.freeze
+
+  class FakeLogger
+    attr_reader :events
+
+    def initialize
+      @events = []
+    end
+
+    def event(name, **attrs)
+      unless Hive::Daemon::Logger::EVENTS.include?(name)
+        raise ArgumentError, "FakeLogger rejected event #{name.inspect}"
+      end
+      @events << [ name, attrs ]
+    end
+  end
+
+  class FakeProbe
+    attr_accessor :universal, :codex, :claude
+
+    def initialize
+      @universal = Result.new(name: "universal", healthy: true, status: "healthy", detail: "ok")
+      @codex = Result.new(name: "codex_auth", healthy: true, status: "healthy", detail: "ok")
+      @claude = Result.new(name: "claude_launcher", healthy: true, status: "healthy", detail: "ok")
+    end
+
+    def probe_universal(config: nil, project_root: nil, stage: nil) = @universal
+    def probe_codex_auth(env: nil) = @codex
+    def probe_claude_launcher(config: nil, project_root: nil, env: nil, wrapper_path: nil, code_fingerprint: nil, stage: nil, universal_result: nil) = @claude
+  end
+
+  def setup
+    @logger = FakeLogger.new
+    @controller = Hive::Daemon::ConcurrencyController.new(
+      max_concurrent_runs: 4, max_concurrent_per_project: 2, max_runs_per_day_per_project: 50
+    )
+  end
+
+  def build_healer(probe:, auto_retry_enabled: true, worktree_clean: true)
+    healer = Hive::Daemon::StaleAgentHealer.new(
+      controller: @controller,
+      logger: @logger,
+      grace_sec: 300,
+      probe: probe,
+      auto_retry_enabled: auto_retry_enabled,
+      project_config_resolver: ->(_name) { [ HEADLESS_CFG, nil ] }
+    )
+    healer.define_singleton_method(:worktree_clean?, ->(_row) { worktree_clean }) unless worktree_clean == :real
+    healer
+  end
+
+  def status_rows_via_consumer(dir)
+    out, _err = capture_io do
+      Hive::Commands::Status.new(json: true).call
+    rescue Hive::Error
+      # status exits non-zero when no tasks; that's fine here
+    end
+    doc = JSON.parse(out)
+    rows = []
+    Array(doc["projects"]).each do |project|
+      Array(project["tasks"]).each do |task|
+        rows << Hive::Daemon::StatusConsumer::Row.new(
+          project: project["name"], slug: task["slug"], stage: task["stage"],
+          marker: task["marker"], marker_attrs: task["attrs"], folder: task["folder"],
+          state_file: task["state_file"], state_file_mtime: task["mtime"] ? Time.parse(task["mtime"]) : nil,
+          action: task["action"], suggested_command: task["suggested_command"],
+          claude_pid_alive: task["claude_pid_alive"], live_task_lock: task["live_task_lock"],
+          diagnostic: task["diagnostic"]
+        )
+      end
+    end
+    rows
+  end
+
+  def seed_execute_error(dir, slug, marker_line)
+    folder = File.join(dir, ".hive-state", "stages", "4-execute", slug)
+    FileUtils.mkdir_p(folder)
+    state_file = File.join(folder, "task.md")
+    File.write(state_file, "---\nslug: #{slug}\n---\n\n# #{slug}\n\n#{marker_line}\n")
+    pre_clear_mtime = Time.now - 1000
+    File.utime(pre_clear_mtime, pre_clear_mtime, state_file)
+    [ folder, state_file ]
+  end
+
+  def seed_plan_error(dir, slug, marker_line)
+    folder = File.join(dir, ".hive-state", "stages", "3-plan", slug)
+    FileUtils.mkdir_p(folder)
+    state_file = File.join(folder, "plan.md")
+    File.write(state_file, "# plan\n\n#{marker_line}\n")
+    pre_clear_mtime = Time.now - 1000
+    File.utime(pre_clear_mtime, pre_clear_mtime, state_file)
+    [ folder, state_file ]
+  end
+
+  def test_codex_401_auto_retry_clears_redispatches_and_emits_event
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        capture_io { Hive::Commands::Init.new(dir).call }
+        slug = "codex-401-260701-aaaa"
+        folder, state_file = seed_execute_error(
+          dir, slug,
+          "<!-- ERROR reason=implementer_failed marker_id=err-a message=\"codex exec returned 401 Missing bearer/basic auth\" -->"
+        )
+
+        row = status_rows_via_consumer(dir).find { |candidate| candidate.slug == slug }
+        assert row, "status pipeline must include the seeded task"
+        assert_equal "error", row.marker
+        assert_equal "implementer_failed", row.marker_attrs["reason"]
+        assert_match(/401 Missing bearer\/basic auth/, row.marker_attrs["message"].to_s)
+
+        build_healer(probe: FakeProbe.new).heal([ row ], now: Time.now)
+
+        assert Hive::Markers.current(state_file).none?, "the Codex-401 marker must clear"
+        assert(@logger.events.any? { |name, attrs| name == :marker_healed && attrs[:reason] == "codex_auth_recovered" },
+               "expected codex_auth_recovered marker_healed, got: #{@logger.events.inspect}")
+
+        # The task events.jsonl must carry the auto_retry audit line.
+        assert_includes File.read(File.join(folder, "events.jsonl")), "\"event_type\":\"auto_retry\""
+
+        # The clear + pre-clear mtime baseline must make Policy re-dispatch.
+        baseline = @controller.last_dispatched_state_file_mtime_for(project: File.basename(dir), slug: slug)
+        assert baseline, "heal must seed a dispatch baseline"
+        post_clear_row = status_rows_via_consumer(dir).find { |candidate| candidate.slug == slug }
+        decision = Hive::Daemon::Policy.decide(
+          action: post_clear_row.action,
+          stage: post_clear_row.stage,
+          command: post_clear_row.suggested_command,
+          state_file_mtime: post_clear_row.state_file_mtime,
+          last_dispatched_state_file_mtime: baseline,
+          now: post_clear_row.state_file_mtime + 3600,
+          edit_debounce_sec: 30
+        )
+        assert_equal :dispatch, decision, "a cleared markerless execute row must re-dispatch, not strand"
+      end
+    end
+  end
+
+  def test_unknown_implementer_failed_stays_parked_through_status_pipeline
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        capture_io { Hive::Commands::Init.new(dir).call }
+        slug = "impl-fail-260701-bbbb"
+        _folder, state_file = seed_execute_error(
+          dir, slug,
+          "<!-- ERROR reason=implementer_failed marker_id=err-b message=\"exit_code=1\" -->"
+        )
+
+        row = status_rows_via_consumer(dir).find { |candidate| candidate.slug == slug }
+        assert row
+        probe = FakeProbe.new
+        build_healer(probe: probe).heal([ row ], now: Time.now)
+
+        assert_match(/ERROR reason=implementer_failed/, File.read(state_file),
+                     "an implementer_failed without a Codex-401 signature must stay parked")
+        assert_empty @logger.events.select { |name, _| name == :marker_healed }
+      end
+    end
+  end
+
+  def test_kill_switch_disables_auto_retry
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        capture_io { Hive::Commands::Init.new(dir).call }
+        slug = "codex-401-off-260701-cccc"
+        _folder, state_file = seed_execute_error(
+          dir, slug,
+          "<!-- ERROR reason=implementer_failed marker_id=err-c message=\"codex exec returned 401 Missing bearer/basic auth\" -->"
+        )
+
+        row = status_rows_via_consumer(dir).find { |candidate| candidate.slug == slug }
+        assert row
+        build_healer(probe: FakeProbe.new, auto_retry_enabled: false).heal([ row ], now: Time.now)
+
+        assert_match(/ERROR reason=implementer_failed/, File.read(state_file),
+                     "kill-switch off must leave the marker parked")
+        assert_empty @logger.events.select { |name, _| name == :marker_healed }
+      end
+    end
+  end
+
+  def test_3_plan_probe_gated_recovery_requeues_through_real_queue
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        capture_io { Hive::Commands::Init.new(dir).call }
+        slug = "claude-plan-260701-dddd"
+        _folder, state_file = seed_plan_error(
+          dir, slug,
+          "<!-- ERROR reason=claude_launch_failed marker_id=err-d message=\"claude interactive prompt did not become ready\" -->"
+        )
+
+        row = status_rows_via_consumer(dir).find { |candidate| candidate.slug == slug }
+        assert row, "status pipeline must include the seeded 3-plan task"
+        assert_equal "3-plan", row.stage
+        assert_equal "claude_launch_failed", row.marker_attrs["reason"]
+
+        build_healer(probe: FakeProbe.new).heal([ row ], now: Time.now)
+
+        assert Hive::Markers.current(state_file).none?, "the probe-gated 3-plan marker must clear"
+        pending = Hive::Daemon::DispatchRequestQueue.pending
+        request = pending.find { |r| r.slug == slug }
+        refute_nil request, "3-plan recovery must land a rerun in the REAL queue"
+        assert_equal [ "hive", "plan", slug, "--project", File.basename(dir), "--from", "3-plan" ],
+                     request.argv
+        assert_equal "healer", request.requestor
+      end
+    end
+  end
+end
diff --git a/test/unit/config_test.rb b/test/unit/config_test.rb
index f9b9a92d6..c74a50665 100644
--- a/test/unit/config_test.rb
+++ b/test/unit/config_test.rb
@@ -2795,6 +2795,14 @@ class ConfigTest < Minitest::Test
     end
   end
 
+  def test_load_returns_daemon_auto_retry_enabled_by_default
+    with_tmp_dir do |dir|
+      cfg = Hive::Config.load(dir)
+      assert_equal true, cfg.dig("daemon", "auto_retry", "enabled"),
+                   "probe-gated auto-retry must be enabled by default (kill-switch is opt-out)"
+    end
+  end
+
   def test_load_rejects_negative_daemon_child_timeout_sec
     with_tmp_dir do |dir|
       FileUtils.mkdir_p(File.join(dir, ".hive-state"))
diff --git a/test/unit/daemon/dispatcher_test.rb b/test/unit/daemon/dispatcher_test.rb
index d5de27822..14a16016e 100644
--- a/test/unit/daemon/dispatcher_test.rb
+++ b/test/unit/daemon/dispatcher_test.rb
@@ -1888,6 +1888,27 @@ class HiveDaemonDispatcherTest < Minitest::Test
                  "rebuilt healer must carry the reloaded grace value"
   end
 
+  def test_build_stale_agent_healer_gates_auto_retry_on_kill_switch
+    dispatcher, _sup, _ctrl, _logger, _mw = make_dispatcher
+
+    # Key absent ⇒ enabled (the `!= false` gate defaults to on).
+    dispatcher.instance_variable_set(:@daemon_cfg, {})
+    assert_equal true,
+                 dispatcher.send(:build_stale_agent_healer, 300).instance_variable_get(:@auto_retry_enabled),
+                 "an absent daemon.auto_retry.enabled key must default the kill-switch to enabled"
+
+    # Explicit true ⇒ enabled.
+    dispatcher.instance_variable_set(:@daemon_cfg, { "auto_retry" => { "enabled" => true } })
+    assert_equal true,
+                 dispatcher.send(:build_stale_agent_healer, 300).instance_variable_get(:@auto_retry_enabled)
+
+    # Explicit false ⇒ disabled.
+    dispatcher.instance_variable_set(:@daemon_cfg, { "auto_retry" => { "enabled" => false } })
+    assert_equal false,
+                 dispatcher.send(:build_stale_agent_healer, 300).instance_variable_get(:@auto_retry_enabled),
+                 "daemon.auto_retry.enabled: false must disable probe-gated auto-retry"
+  end
+
 def test_run_forever_reloads_ticks_and_shuts_down_cleanly
   dispatcher, supervisor, _ctrl, logger, _mw = make_dispatcher
   ticks = 0
diff --git a/test/unit/daemon/health_probe_test.rb b/test/unit/daemon/health_probe_test.rb
new file mode 100644
index 000000000..8d452c278
--- /dev/null
+++ b/test/unit/daemon/health_probe_test.rb
@@ -0,0 +1,420 @@
+require "test_helper"
+require "tmpdir"
+require "timeout"
+require "hive/daemon/health_probe"
+require "hive/agent_profiles"
+
+# The health probe engine must answer "is this dependency healthy?" without
+# ever raising, and must be fully driveable with injected fakes (no real
+# codex/claude/tmux binary). These tests pin every branch: healthy and
+# unhealthy paths for each probe, the shell-runner's fail-closed edges, and
+# the exception-to-unhealthy degradation that protects a daemon tick.
+class HiveDaemonHealthProbeTest < Minitest::Test
+  include HiveTestHelper
+
+  HEADLESS_CFG = { "claude" => { "mode" => "headless" } }.freeze
+  TMUX_CFG = { "claude" => { "mode" => "tmux" } }.freeze
+
+  CommandResult = Hive::Daemon::HealthProbe::CommandResult
+
+  # A runner fake keyed by command prefix. `capture3` returns the first
+  # registered key that prefixes the argv, or a default failure.
+  class FakeRunner
+    attr_reader :calls
+
+    def initialize
+      @calls = []
+      @responses = {}
+    end
+
+    def on(prefix, result)
+      @responses[prefix] = result
+    end
+
+    def capture3(argv, env:, timeout_sec:)
+      @calls << { argv: argv, env: env, timeout_sec: timeout_sec }
+      key = @responses.keys.find { |prefix| argv[0, prefix.length] == prefix }
+      key ? @responses[key] : CommandResult.new(stdout: "", stderr: "", exitstatus: 1)
+    end
+  end
+
+  def ok_result(stdout: "logged in", stderr: "", exitstatus: 0)
+    CommandResult.new(stdout: stdout, stderr: stderr, exitstatus: exitstatus)
+  end
+
+  def fake_doctor(rows)
+    Class.new do
+      define_method(:initialize) { |**| }
+      define_method(:call) { }
+      define_method(:rows) { rows }
+    end
+  end
+
+  def fake_claude_profile(check_raises: nil)
+    profile = Object.new
+    profile.define_singleton_method(:check_version!) do
+      raise check_raises if check_raises
+
+      "2.1.118"
+    end
+    profile.define_singleton_method(:format_skill_invocation) { |skill| skill }
+    profile.define_singleton_method(:verify_skill) { |_invocation, project_root: nil| [ :present, "ok" ] }
+    profile
+  end
+
+  def with_wrapper_file
+    Dir.mktmpdir do |dir|
+      path = File.join(dir, "wrapper.sh")
+      File.write(path, "#!/bin/sh\n")
+      yield path
+    end
+  end
+
+  def make_probe(config: HEADLESS_CFG, runner: nil, doctor_factory: nil, project_root: nil)
+    Hive::Daemon::HealthProbe.new(
+      config: config, project_root: project_root,
+      runner: runner, doctor_factory: doctor_factory
+    )
+  end
+
+  # ── Result / CommandResult ─────────────────────────────────────────────
+
+  def test_result_coerces_and_defaults_status
+    result = Hive::Daemon::HealthProbe::Result.new(name: "x", healthy: true)
+    assert result.healthy?
+    assert_equal "healthy", result.status
+    assert_equal "", result.detail
+    assert_equal 0.0, result.elapsed_sec
+
+    falsey = Hive::Daemon::HealthProbe::Result.new(name: "y", healthy: false, status: "unhealthy", detail: "d")
+    refute falsey.healthy?
+    assert_equal "unhealthy", falsey.status
+    assert_equal "d", falsey.detail
+  end
+
+  def test_command_result_success_and_output
+    ok = CommandResult.new(stdout: "a\n", stderr: "b", exitstatus: 0)
+    assert ok.success?
+    assert_equal "a\nb", ok.output
+
+    fail = CommandResult.new(stdout: "", stderr: "", exitstatus: 1)
+    refute fail.success?
+    assert_equal "", fail.output
+  end
+
+  # ── ShellRunner ────────────────────────────────────────────────────────
+
+  def test_shell_runner_captures_success
+    status = Struct.new(:exitstatus).new(0)
+    with_replaced_singleton_method(Open3, :capture3, ->(_env, *argv) { [ "out", "err", status ] }) do
+      result = Hive::Daemon::HealthProbe::ShellRunner.new.capture3([ "codex" ], env: {}, timeout_sec: 1)
+      assert result.success?
+      assert_equal "out", result.stdout
+      assert_equal "err", result.stderr
+    end
+  end
+
+  def test_shell_runner_maps_missing_binary_to_127
+    with_replaced_singleton_method(Open3, :capture3, ->(*_args) { raise Errno::ENOENT, "codex" }) do
+      result = Hive::Daemon::HealthProbe::ShellRunner.new.capture3([ "codex" ], env: {}, timeout_sec: 1)
+      assert_equal 127, result.exitstatus
+      refute result.success?
+    end
+  end
+
+  def test_shell_runner_maps_timeout_to_124
+    with_replaced_singleton_method(Timeout, :timeout, ->(_sec, &_block) { raise Timeout::Error }) do
+      result = Hive::Daemon::HealthProbe::ShellRunner.new.capture3([ "codex" ], env: {}, timeout_sec: 1)
+      assert_equal 124, result.exitstatus
+      refute result.success?
+    end
+  end
+
+  # ── universal ──────────────────────────────────────────────────────────
+
+  def test_universal_healthy_when_no_failing_doctor_rows
+    probe = make_probe(doctor_factory: fake_doctor([ { label: "a", status: "present" } ]))
+    result = probe.probe_universal
+    assert result.healthy?
+    assert_match(/doctor green/, result.detail)
+  end
+
+  def test_universal_unhealthy_on_missing_row
+    probe = make_probe(doctor_factory: fake_doctor([
+      { label: "brainstorm", status: "missing" },
+      { label: "tmux", status: "version_too_old" }
+    ]))
+    result = probe.probe_universal
+    refute result.healthy?
+    assert_match(/brainstorm=missing/, result.detail)
+    assert_match(/tmux=version_too_old/, result.detail)
+  end
+
+  def test_universal_unhealthy_when_stage_skill_missing
+    profile = Object.new
+    profile.define_singleton_method(:format_skill_invocation) { |skill| skill }
+    profile.define_singleton_method(:verify_skill) { |_invocation, project_root: nil| [ :missing, "nope" ] }
+    with_replaced_singleton_method(Hive::AgentProfiles, :lookup, ->(_name, cfg: nil) { profile }) do
+      probe = make_probe(doctor_factory: fake_doctor([]))
+      result = probe.probe_universal(stage: "3-plan")
+      refute result.healthy?
+      assert_match(/plan skill/, result.detail)
+    end
+  end
+
+  def test_universal_rescues_doctor_exception_to_unhealthy
+    boom = Class.new do
+      define_method(:initialize) { |**| }
+      define_method(:call) { raise ArgumentError, "boom" }
+      define_method(:rows) { [] }
+    end
+    probe = make_probe(doctor_factory: boom)
+    result = probe.probe_universal
+    refute result.healthy?
+    assert_match(/ArgumentError: boom/, result.detail)
+  end
+
+  def test_universal_unhealthy_when_doctor_returns_no_rows
+    # A doctor that hits its config-error rescue returns EXIT_CONFIG_ERROR
+    # without assigning @rows. The probe must treat nil rows as "probe error,
+    # not healthy" — never as "no failing rows ⇒ green".
+    nil_rows = Class.new do
+      define_method(:initialize) { |**| }
+      define_method(:call) { 78 } # Hive::Commands::Doctor::EXIT_CONFIG_ERROR
+      define_method(:rows) { nil }
+    end
+    probe = make_probe(doctor_factory: nil_rows)
+    result = probe.probe_universal
+    refute result.healthy?
+    assert_match(/config error/, result.detail)
+  end
+
+  def test_universal_returns_unhealthy_on_timeout
+    # A hung in-process doctor (e.g. an unbounded tmux `-V` shell-out) must
+    # be bounded by UNIVERSAL_PROBE_TIMEOUT_SEC and degrade to unhealthy,
+    # never block the daemon tick (R5).
+    with_replaced_singleton_method(Timeout, :timeout, ->(_sec, &_block) { raise Timeout::Error }) do
+      probe = make_probe(doctor_factory: fake_doctor([]))
+      result = probe.probe_universal
+      refute result.healthy?
+      assert_match(/Timeout::Error/, result.detail)
+    end
+  end
+
+  # ── codex auth ─────────────────────────────────────────────────────────
+
+  def test_codex_auth_healthy_when_login_and_smoke_pass
+    runner = FakeRunner.new
+    runner.on([ "codex", "login", "status" ], ok_result)
+    runner.on([ "codex", "exec" ], ok_result(stdout: "ok"))
+    with_replaced_singleton_method(Hive::AgentProfiles, :logged_in?, ->(_name, home: Dir.home) { true }) do
+      result = make_probe(runner: runner).probe_codex_auth(env: {})
+      assert result.healthy?, result.detail
+      assert_match(/smoke test passed/, result.detail)
+    end
+  end
+
+  def test_codex_auth_unhealthy_without_credential
+    with_replaced_singleton_method(Hive::AgentProfiles, :logged_in?, ->(_name, home: Dir.home) { false }) do
+      result = make_probe.probe_codex_auth(env: {})
+      refute result.healthy?
+      assert_match(/auth.json/, result.detail)
+    end
+  end
+
+  def test_codex_auth_unhealthy_when_login_reports_not_logged_in
+    runner = FakeRunner.new
+    runner.on([ "codex", "login", "status" ], ok_result(stdout: "not logged in"))
+    with_replaced_singleton_method(Hive::AgentProfiles, :logged_in?, ->(_name, home: Dir.home) { true }) do
+      result = make_probe(runner: runner).probe_codex_auth(env: {})
+      refute result.healthy?
+      assert_match(/not logged in/, result.detail)
+    end
+  end
+
+  def test_codex_auth_falls_back_to_auth_status_on_unknown_command
+    runner = FakeRunner.new
+    runner.on([ "codex", "login", "status" ], CommandResult.new(stdout: "", stderr: "unknown command: login", exitstatus: 2))
+    runner.on([ "codex", "auth", "status" ], ok_result)
+    runner.on([ "codex", "exec" ], ok_result(stdout: "ok"))
+    with_replaced_singleton_method(Hive::AgentProfiles, :logged_in?, ->(_name, home: Dir.home) { true }) do
+      result = make_probe(runner: runner).probe_codex_auth(env: {})
+      assert result.healthy?, result.detail
+      assert_includes runner.calls.map { |c| c[:argv] }, [ "codex", "auth", "status" ],
+                      "the unknown-command shape must trigger the auth status fallback"
+    end
+  end
+
+  def test_codex_auth_unhealthy_when_fallback_also_fails
+    runner = FakeRunner.new
+    runner.on([ "codex", "login", "status" ], CommandResult.new(stdout: "", stderr: "unknown command", exitstatus: 2))
+    runner.on([ "codex", "auth", "status" ], CommandResult.new(stdout: "", stderr: "no", exitstatus: 1))
+    with_replaced_singleton_method(Hive::AgentProfiles, :logged_in?, ->(_name, home: Dir.home) { true }) do
+      result = make_probe(runner: runner).probe_codex_auth(env: {})
+      refute result.healthy?
+      assert_match(/auth status/, result.detail)
+    end
+  end
+
+  def test_codex_auth_unhealthy_when_smoke_fails
+    runner = FakeRunner.new
+    runner.on([ "codex", "login", "status" ], ok_result)
+    runner.on([ "codex", "exec" ], CommandResult.new(stdout: "", stderr: "boom", exitstatus: 1))
+    with_replaced_singleton_method(Hive::AgentProfiles, :logged_in?, ->(_name, home: Dir.home) { true }) do
+      result = make_probe(runner: runner).probe_codex_auth(env: {})
+      refute result.healthy?
+      assert_match(/smoke test failed/, result.detail)
+    end
+  end
+
+  # ── claude launcher ────────────────────────────────────────────────────
+
+  def test_claude_launcher_unhealthy_when_wrapper_missing
+    result = make_probe.probe_claude_launcher(wrapper_path: "/nonexistent/wrapper.sh", code_fingerprint: nil)
+    refute result.healthy?
+    assert_match(/wrapper missing/, result.detail)
+  end
+
+  def test_claude_launcher_unhealthy_when_tmux_not_present
+    with_wrapper_file do |wrapper|
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :tmux_status, -> { [ :missing, "tmux not runnable" ] }) do
+        result = make_probe(config: TMUX_CFG).probe_claude_launcher(wrapper_path: wrapper, code_fingerprint: nil)
+        refute result.healthy?
+        assert_match(/tmux not runnable/, result.detail)
+      end
+    end
+  end
+
+  def test_claude_launcher_unhealthy_when_version_check_raises
+    with_wrapper_file do |wrapper|
+      profile = fake_claude_profile(check_raises: Hive::AgentError.new("claude binary not runnable: claude"))
+      with_replaced_singleton_method(Hive::AgentProfiles, :lookup, ->(_name, cfg: nil) { profile }) do
+        result = make_probe.probe_claude_launcher(wrapper_path: wrapper, code_fingerprint: nil)
+        refute result.healthy?
+        assert_match(/not runnable/, result.detail)
+      end
+    end
+  end
+
+  def test_claude_launcher_unhealthy_when_code_fingerprint_mismatches
+    with_wrapper_file do |wrapper|
+      profile = fake_claude_profile
+      with_replaced_singleton_method(Hive::AgentProfiles, :lookup, ->(_name, cfg: nil) { profile }) do
+        result = make_probe.probe_claude_launcher(wrapper_path: wrapper, code_fingerprint: "deadbeef")
+        refute result.healthy?
+        assert_match(/does not match/, result.detail)
+      end
+    end
+  end
+
+  def test_claude_launcher_healthy_when_all_checks_pass
+    with_wrapper_file do |wrapper|
+      profile = fake_claude_profile
+      with_replaced_singleton_method(Hive::AgentProfiles, :lookup, ->(_name, cfg: nil) { profile }) do
+        probe = make_probe(doctor_factory: fake_doctor([]))
+        result = probe.probe_claude_launcher(wrapper_path: wrapper, code_fingerprint: nil)
+        assert result.healthy?, result.detail
+        assert_match(/all green/, result.detail)
+      end
+    end
+  end
+
+  def test_claude_launcher_reuses_precomputed_universal_result
+    # When the healer already ran the universal probe this cycle, the claude
+    # probe must reuse it instead of building a second `hive doctor` (R6).
+    doctor_builds = []
+    doctor_class = Class.new do
+      define_method(:initialize) { |**| }
+      define_method(:call) { }
+      define_method(:rows) { [] }
+    end
+    factory = Class.new(doctor_class)
+    factory.define_singleton_method(:new) do |*args, **kwargs|
+      doctor_builds << :doctor
+      super(*args, **kwargs)
+    end
+
+    probe = make_probe(doctor_factory: factory)
+    universal = Hive::Daemon::HealthProbe::Result.new(name: "universal", healthy: true, status: "healthy", detail: "ok")
+    with_wrapper_file do |wrapper|
+      profile = fake_claude_profile
+      with_replaced_singleton_method(Hive::AgentProfiles, :lookup, ->(_name, cfg: nil) { profile }) do
+        result = probe.probe_claude_launcher(wrapper_path: wrapper, code_fingerprint: nil, universal_result: universal)
+        assert result.healthy?, result.detail
+        assert_empty doctor_builds, "a precomputed universal result must skip the doctor build"
+      end
+    end
+  end
+
+  # ── helper edge coverage ───────────────────────────────────────────────
+
+  def test_codex_home_and_bin_env_resolution
+    probe = make_probe
+    assert_equal "/opt/codex", probe.send(:codex_home, { "CODEX_HOME" => "/opt/codex" })
+    assert_equal "/home/u", probe.send(:codex_home, { "HOME" => "/home/u" })
+    assert_equal Dir.home, probe.send(:codex_home, {})
+    assert_equal "/bin/codex", probe.send(:codex_bin, { "HIVE_CODEX_BIN" => "/bin/codex" })
+    assert_equal "codex", probe.send(:codex_bin, {})
+  end
+
+  def test_login_status_ok_and_unknown_command_predicates
+    probe = make_probe
+    assert probe.send(:login_status_ok?, ok_result(stdout: "Logged in as user@example.com"))
+    refute probe.send(:login_status_ok?, ok_result(stdout: "not logged in"))
+    refute probe.send(:login_status_ok?, CommandResult.new(stdout: "", stderr: "", exitstatus: 1))
+
+    assert probe.send(:unknown_command?, CommandResult.new(stdout: "", stderr: "unknown command", exitstatus: 2))
+    refute probe.send(:unknown_command?, ok_result)
+  end
+
+  def test_claude_version_check_returns_unhealthy_on_generic_error
+    profile = fake_claude_profile(check_raises: RuntimeError.new("kaboom"))
+    with_replaced_singleton_method(Hive::AgentProfiles, :lookup, ->(_name, cfg: nil) { profile }) do
+      step = make_probe.send(:claude_version_check, {})
+      refute step.ok
+      assert_match(/RuntimeError: kaboom/, step.detail)
+    end
+  end
+
+  def test_code_fingerprint_match_returns_nil_when_fresh_digest_unavailable
+    with_replaced_singleton_method(Digest::SHA256, :file, ->(_path) { raise Errno::ENOENT }) do
+      detail = make_probe.send(:code_fingerprint_match, "anything")
+      assert_match(/could not compute/, detail)
+    end
+  end
+
+  def test_stage_skill_failure_returns_nil_for_skillless_stage
+    probe = make_probe
+    assert_nil probe.send(:stage_skill_failure, "4-execute")
+    assert_nil probe.send(:stage_skill_failure, nil)
+  end
+
+  def test_stage_skill_failure_rescues_lookup_error
+    with_replaced_singleton_method(Hive::AgentProfiles, :lookup, ->(*_args, **_kwargs) { raise Hive::ConfigError, "nope" }) do
+      failure = make_probe.send(:stage_skill_failure, "3-plan")
+      assert_match(/plan skill check failed/, failure)
+    end
+  end
+
+  def test_stage_config_key_strips_numeric_prefix
+    probe = make_probe
+    assert_equal "execute", probe.send(:stage_config_key, "4-execute")
+    assert_nil probe.send(:stage_config_key, nil)
+  end
+
+  def test_stage_config_key_normalizes_hyphenated_stage_to_underscore_key
+    probe = make_probe
+    assert_equal "open_pr", probe.send(:stage_config_key, "5-open-pr")
+    assert_equal "artifacts", probe.send(:stage_config_key, "7-artifacts")
+    assert_equal "finalize", probe.send(:stage_config_key, "8-finalize")
+  end
+
+  def test_failing_desc_empty_for_no_failing_rows
+    assert_nil make_probe.send(:failing_desc, [])
+  end
+
+  def test_wrapper_path_class_and_instance_resolve_consistently
+    assert_equal Hive::Daemon::HealthProbe.wrapper_path, make_probe.send(:default_wrapper_path)
+    assert File.file?(Hive::Daemon::HealthProbe.wrapper_path)
+  end
+end
